---
title: 'XRSystem: devicechange event'
slug: Web/API/XRSystem/devicechange_event
tags:
  - API
  - AR
  - Augmented Reality
  - Reference
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XR
  - XRSystem
  - devicechange
---
<div>{{APIRef("WebXR Device API")}}</div>

<p><span class="seoSummary">A <strong><code>devicechange</code></strong> event is fired on an {{DOMxRef("XRSystem")}} object whenever the whenever the availability of immersive XR devices has changed; for example, a VR headset or AR goggles have been connected or disconnected.</span> It's a generic {{DOMxRef("Event")}} with no added properties.</p>

<div class="notecard note">
<p><strong>Note:</strong> Not to be confused with the {{domxref("MediaDevices")}} {{DOMxRef("MediaDevices.devicechange_event", "devicechange")}} event.</p>
</div>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler</th>
   <td>{{DOMxRef("XRSystem.ondevicechange")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Usage_notes">Usage notes</h2>

<p><code>devicechange</code> events are not delivered if the document which owns the <strong>{{domxref("XRSystem")}}</strong> object has been granted permission to do so through the <code><a href="/en-US/docs/Web/HTTP/Headers/Feature-Policy/xr-spatial-tracking">xr-spatial-tracking</a></code> feature policy.</p>

<p>You can use this event to, for example, monitor for the availability of a WebXR-compatible device so that you can enable a UI element which the user can use to activate immersive mode. This is shown in the {{anch("Example", "example")}} below.</p>

<h2 id="Example">Example</h2>

<p>The example shown here handles the <code>devicechange</code> event by toggling the availability of the "Enter XR" button based on whether or not any immersive devices are currently available.</p>

<pre class="brush: js">if (navigator.xr) {
  navigator.xr.addEventListener("devicechange", event =&gt; {
    navigator.xr.isSessionSupported("immersive-vr")
    .then(immersiveOK) =&gt; {
      if (immersiveOK) {
        enableXRButton.disabled = false;
      } else {
        enableXRButton.disabled = true;
      }
    });
  });
}

</pre>

<p>When <code>devicechange</code> is received, the handler set up in this code calls the <code>XR</code> method {{domxref("XRSystem.isSessionSupported", "isSessionSupported()")}} to find out if there's a device available that can handle immersive VR presentations. If there is, the button to enter XR mode is enabled; otherwise it's disabled.</p>

<p>You can also use the {{domxref("XRSystem.ondevicechange", "ondevicechange")}} event handler property to set a single handler for <code>devicechange</code> events:</p>

<pre class="brush: js">if (navigator.xr) {
  navigator.xr.ondevicechange = event =&gt; {
    /* ... etc ... */
  };
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#eventdef-xrsystem-devicechange","devicechange event")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRSystem.devicechange_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("XRSystem.ondevicechange")}}</li>
</ul>
